use encoding "shiftjis";

require './codeconfig.cgi';

$IssuedListFile = $IssuedListFileHeader . $ARGV[0] . ".dat";
$CodeListFile = "code" . $ARGV[0] . ".html";
$MMDD = $ARGV[0];
$MMDD =~ s/.*(\d\d\d\d)$/$1/;
$CodeListTxt = "codelist". $MMDD . ".txt";

$dbistr = "dbi";
#$dbistr = "";
$dbip = 0;

%colors = ("46051S1)" => "#DDFFFF",
	   "46051S1N4)" => "#CCEEFF",
	   "46051S1N3N4)" => "#CCCCFF",
	   "46051)" => "#DDEEFF",
	   "46051N4)" => "#BBEEFF",
	   "46050N4)" => "#CCFFEE",
	   "46050)" => "#EEFFDD",
	   "46051S1N4N57)" => "#AAFFFF",
	   "46050N4N57)" => "#EEFFEE",
	   "Firefox/1.5.0.6" => "#FFDDFF",
	   "5.1j Ff/1.5.0.6" => "#FFDDFF",
	   "Firefox/1.5.0.7" => "#FFBBFF",
	   "5.1j Ff/1.5.0.7" => "#FFBBFF",
	   "5.0j Ff/1.5.0.7" => "#FFDDEE",
	   "Netscape/7.0" => "#FFCCEE", 
	   "5.1jJ Ns/7.0" => "#FFCCEE", 
	   "Mozilla/4.08 (P" => "#FFEEBB", 
	   "408 P33 NF/3.3" =>  "#FFEEBB", 
	   "DoCoMo/1.0/D501" => "#FFFFCC",
	   "*" => "RED",
	   "P80" => "#FFDDEE",
	   "201" => "#CCDDFF",
	   "202" => "#FFDDAA",
	   "203" => "#FFDDAA",
	   "204" => "#FFDDCC",
	   "212" => "#FFBBAA",
	   "213" => "#FFBBAA",
	   "214" => "#FFBBAA",
	   "221" => "#FF8888",
	   "301" => "#FFDDFF",
	   "302" => "#FFDDFF",
	   "303" => "#FFDDFF");


foreach (@AttentionDomain) {
    @tmplist = split(/<>/);
    if ( $tmplist[0] eq "*" ) {
	next;
    }
    if ( $tmplist[1] eq "*" ) {
	$colors{$tmplist[0]} = "#CCCCFF";
    } else {
	if ( !$colors{$tmplist[0]} ) {
	    $colors{$tmplist[0]} = "#E0F0FF";
	}
	$tmplist[0] .= "*";
	$colors{$tmplist[0]} = "#CCDDFF";
    }
}

foreach (@AttentionDomainS) {
    @tmplist = split(/<>/);
    if ( $tmplist[0] eq "*" ) {
	next;
    }
    if ( $tmplist[1] eq "*" ) {
	$colors{$tmplist[0]} = "#AAAAFF";
    } else {
	if ( !$colors{$tmplist[0]} ) {
	    $colors{$tmplist[0]} = "#E0F0FF";
	}
	$tmplist[0] .= "**";
	$colors{$tmplist[0]} = "#AABBFF";
    }
}

foreach (@AttentionDomain2) {
    @tmplist = split(/<>/);
    if ( $tmplist[0] eq "*" ) {
	next;
    }
    if ( $tmplist[1] eq "*" ) {
	$colors{$tmplist[0]} = "#FFCCCC";
    } else {
	$colors{$tmplist[0]} = "#FFF0E0";
	$tmplist[0] .= "*";
	$colors{$tmplist[0]} = "#FFDDCC";
    }
}


%IssuedList = ();
%VoteList = ();

if(-e $CodeListTxt) {
    open(CLT, "$CodeListTxt");
    while(<CLT>) {
	chop;
	@tmp = split(/ /);
	$VoteList{$tmp[1]} = $tmp[2];
	$VoteNum{$tmp[1]} = $tmp[0];
    }
}


open(PLF, "$ProxyLogFile");
while(<PLF>) {
    chop;
    @tmp = split(/<>/);
    if ( $tmp[5] =~ /P/ ) {
	$colors{$tmp[0]} = "#FFDDEE";
    }
}
close(PLF);


open CLF, ">:encoding(shift-jis)", "$CodeListFile";
print CLF "<HTML>\n";
print CLF "<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n";
print CLF "<BODY>\n";

print CLF "<A HREF=\"#reserve\">\</A>@<A HREF=\"#provider\">voC_</A>@<A HREF=\"#browser\">uEU</A>@<A HREF=\"#vote\">[</A>@<A HREF=\"#proxy\">PROXYO</A>@<A HREF=\"#error\">G[O</A>@<A HREF=\"#forbidden\">ꎞ~hC</A><BR>\n";

### \񏇂ɕ\
print CLF "<A NAME=\"reserve\"></A><B>\</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>\</TH><TH></TH><TH>HOST</TH><TH>hC</TH><TH>uEU</TH>\n";
print CLF "<TH>\񎞍</TH><TH>s\</TH><TH>NbL[</TH><TH>NbL[</TH>\n";
print CLF "<TH>`FCP</TH><TH>`FCQ</TH><TH>̎ʔԍ</TH><TH>L</TH><TH>sR[h</TH>\n";
print CLF "<TH>s</TH><TH>hCQ</TH><TH>`FCc</TH><TH>`FCa</TH><TH>`FCca</TH>";
print CLF "<TH>[</TH><TH>DBI</TH><TH>[ԍ</TH></TR>\n";

open(ILF, "$IssuedListFile");
while(<ILF>) {
    chop;
    $tmpdata = $_;
    &DecodeIssuedList($_);
    $IssuedList{$tmpindex} = $tmpdata;
    $IssuedList2{$tmpindex2} = $tmpdata;
    if ( $VoteNum{$NewCodeData[13]} ) {
	$IssuedList3{$VoteNum{$NewCodeData[13]}} = $tmpdata;
    }

    print CLF "<TR>";
    for($i=0; $i<19; $i++) {
	$tmp = $NewCodeData[$i];
	if ( $tmp ) {
	    if ( $i == 7 || $i == 8 || $i == 11 ) {
		$tmp =~ s/^(.{1}).*/$1/;
	    }
	    &PrintCell($tmp);
	} else {
	    print CLF "<TD>@</TD>";
	}
    }

    if(( $NewCodeData[13] ) && ( $VoteList{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteList{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if( $tmpdbi ) {
	print CLF "<TD NOWRAP>$tmpdbi</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if(( $NewCodeData[13] ) && ( $VoteNum{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteNum{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
	
    print CLF "</TR>\n";
}
close(ILF);    

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";

### voC_ɕ\
print CLF "<A NAME=\"provider\"></A><B>voC_</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>\</TH><TH></TH><TH>HOST</TH><TH>hC</TH><TH>uEU</TH>\n";
print CLF "<TH>\񎞍</TH><TH>s</TH><TH>NbL[</TH>\n";
print CLF "<TH>`FCP</TH><TH>`FCQ</TH><TH>`FCc</TH><TH>`FCca</TH><TH>sR[h</TH><TH>hCQ</TH>\n";
print CLF "<TH>[</TH><TH>DBI</TH><TH>[ԍ</TH><TH>Cookie</TH></TR>\n";

foreach (sort(keys(%IssuedList))) {
    &DecodeIssuedList($IssuedList{$_});
    print CLF "<TR>";
    foreach $i (0..5, 14, 8, 9, 10, 16, 18, 13, 15) {
	$tmp = $NewCodeData[$i];
	if ( $tmp ) {
	    if ( $i == 8 ) {
		$tmp =~ s/^(.{1}).*/$1/;
	    }
	    &PrintCell($tmp);
	} else {
	    print CLF "<TD>@</TD>";
	}
    }
    if(( $NewCodeData[13] ) && ( $VoteList{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteList{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if( $tmpdbi ) {
	print CLF "<TD NOWRAP>$dbistr$tmpdbi</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if(( $NewCodeData[13] ) && ( $VoteNum{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteNum{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    &PrintCell(&CaesarCrypt($NewCodeData[8], -$CaesarKey));
    
    print CLF "</TR>\n";
}

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";

### uEUɕ\
print CLF "<A NAME=\"browser\"></A><B>uEU</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>\</TH><TH></TH><TH>HOST</TH><TH>hC</TH><TH>uEU</TH>\n";
print CLF "<TH>\񎞍</TH><TH>s</TH><TH>NbL[</TH>\n";
print CLF "<TH>`FCP</TH><TH>`FCQ</TH><TH>`FCc</TH><TH>`FCa</TH><TH>`FCca</TH>\n";
print CLF "<TH>sR[h</TH><TH>hCQ</TH><TH>[</TH><TH>DBI</TH><TH>[ԍ</TH></TR>\n";

foreach (sort(keys(%IssuedList2))) {
    &DecodeIssuedList($IssuedList2{$_});
    print CLF "<TR>";
    foreach $i (0..5, 14, 8, 9, 10, 16, 17, 18, 13, 15) {
	$tmp = $NewCodeData[$i];
	if ( $tmp ) {
	    if ( $i == 8 ) {
		$tmp =~ s/^(.{1}).*/$1/;
	    }
	    &PrintCell($tmp);
	} else {
	    print CLF "<TD>@</TD>";
	}
    }
    if(( $NewCodeData[13] ) && ( $VoteList{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteList{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if( $tmpdbi ) {
	print CLF "<TD NOWRAP>$tmpdbi</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if(( $NewCodeData[13] ) && ( $VoteNum{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteNum{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    print CLF "</TR>\n";
}

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";

### [ɕ\
print CLF "<A NAME=\"vote\"></A><B>[</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>\</TH><TH></TH><TH>HOST</TH><TH>hC</TH><TH>uEU</TH>\n";
print CLF "<TH>\񎞍</TH><TH>s</TH><TH>NbL[</TH>\n";
print CLF "<TH>`FCP</TH><TH>`FCQ</TH><TH>`FCc</TH><TH>`FCca</TH><TH>sR[h</TH><TH>hCQ</TH>\n";
print CLF "<TH>[</TH><TH>DBI</TH><TH>[ԍ</TH><TH>Cookie</TH></TR>\n";

foreach (sort(keys(%IssuedList3))) {
    &DecodeIssuedList($IssuedList3{$_});
    print CLF "<TR>";
    foreach $i (0..5, 14, 8, 9, 10, 16, 18, 13, 15) {
	$tmp = $NewCodeData[$i];
	if ( $tmp ) {
	    if ( $i == 8 ) {
		$tmp =~ s/^(.{1}).*/$1/;
	    }
	    &PrintCell($tmp);
	} else {
	    print CLF "<TD>@</TD>";
	}
    }
    if(( $NewCodeData[13] ) && ( $VoteList{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteList{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if( $tmpdbi ) {
	print CLF "<TD NOWRAP>$dbistr$tmpdbi</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    if(( $NewCodeData[13] ) && ( $VoteNum{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteNum{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    &PrintCell(&CaesarCrypt($NewCodeData[8], -$CaesarKey));
    
    print CLF "</TR>\n";
}

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";


### PROXYO̕\
print CLF "<A NAME=\"proxy\"></A><B>PROXYO</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>ԍ</TH><TH></TH><TH>HOST</TH><TH>uEU</TH><TH>e</TH></TR>\n";

open(PLF, "$ProxyLogFile");
while(<PLF>) {
    chop;
    @tmp = split(/<>/);
    if ( $tmp[2] eq $ARGV[0] ) {
	$last = @tmp;
	$tmp[4] = &AbbBrowser($tmp[4]);
	($sec, $min, $hour) = localtime($tmp[1]);
	$tmp[1] = sprintf("%02d:%02d:%02d", $hour, $min, $sec);
	foreach $i (5, 1, 0, 4) {
	    if ( $tmp[$i] ) {
		&PrintCell($tmp[$i]);
	    } else {
		print CLF "<TD>@</TD>";
	    }
	}
	print CLF "<TD>";
	for($i=6; $i<$last; $i++) {
	    print CLF "$tmp[$i]<>";
	}
	print CLF "</TD>";
	print CLF "</TR>\n";
    }
}
close(PLF);

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";


### G[̕\
print CLF "<A NAME=\"error\"></A><B>G[O</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>DBI</TH><TH>G[</TH><TH>HOST</TH><TH></TH>\n";
print CLF "<TH>NbL[</TH><TH>uEU</TH><TH>o^NbL[</TH><TH>o^uEU</TH></TR>\n";

open(ELF, "$ErrorLogFile");
while(<ELF>) {
    chop;
    @tmp = split(/<>/);
    if ( $tmp[3] eq $ARGV[0] ) {

### L蓖
	$RemoteDomain = $tmp[1];
	if ( $RemoteDomain =~ /jp$/ ) {
	    $RemoteDomain =~ s/.*\.(.+?\..+?\.jp)$/$1/;
	    if ( $RemoteDomain !~ /\...\.jp/ ) {
		$RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
		if ( !$DomainPlace{$RemoteDomain} ) {
		    $DomainPlace{$RemoteDomain} = 3;
		}
	    }
	} elsif ( $RemoteDomain =~ /\....$/ ) {
	    $RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
	    if ( !$DomainPlace{$RemoteDomain} ) {
		$DomainPlace{$RemoteDomain} = 3;
	    }
	} else {
	    $RemoteDomain =~ s/.*\.(.+?\..+?\...)$/$1/;
	}

	$RemoteDomain2 = $tmp[1];
	if ( $RemoteDomain eq "bbtec.net" ) {
	    $RemoteDomain2 =~ s/softbank(\d\d\d)\d*\./$1\./;
	} elsif ( $RemoteDomain eq "hi-ho.ne.jp" ) {
	    $RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "hinet.net" ) {
	    $RemoteDomain2 =~ s/^(\d*)\-.*\.(.+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "infoweb.ne.jp" ) {
	    if ( $RemoteDomain2 =~ /\.nt\./ || $RemoteDomain2 =~ /\.te\./ ) {
		$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	    } else {
		$RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?\..+?)$/$1\.$2/;
	    }
	} elsif ( $RemoteDomain eq "mesh.ad.jp" ) {
	    $RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "ocn.ne.jp" ) {
	    $RemoteDomain2 =~ s/\d//g;
	} elsif ( $RemoteDomain eq "odn.ad.jp"  || $RemoteDomain eq "odn.ne.jp" ) {
	    $RemoteDomain2 =~ s/^(.....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "prin.ne.jp" ) {
	    $RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	    $RemoteDomain2 =~ s/kd12/p061/;
	    $RemoteDomain2 =~ s/p125/p061/;
	} elsif ( $RemoteDomain eq "zaq.ne.jp" ) {
	    $RemoteDomain2 =~ s/^zaq(...).*\.(.+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $DomainPlace{$RemoteDomain} == 2 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 3 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 4 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 5 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 6 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 7 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	} else {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
	}
	
	$tmpdb = "$RemoteDomain2<>$tmp[7]";
	$tmpdbi = $DBIdentify{$tmpdb};

	$tmp[7] = &AbbBrowser($tmp[7]);
	$tmp[9] = &AbbBrowser($tmp[9]);
	($sec, $min, $hour) = localtime($tmp[2]);
	$tmp[2] = sprintf("%02d:%02d:%02d", $hour, $min, $sec);
	if( $tmpdbi ) {
	    print CLF "<TD NOWRAP>$tmpdbi</TD>";
	} else {
	    print CLF "<TD>@</TD>";
	}
	foreach $i (0, 1, 2, 5, 7, 8, 9) {
	    if ( $tmp[$i] ) {
		&PrintCell($tmp[$i]);
	    } else {
		print CLF "<TD>@</TD>";
	    }
	}
	print CLF "</TR>\n";
    }
}
close(ELF);

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";

### ꎞ~hC̕\
print CLF "<A NAME=\"forbidden\"></A><B>ꎞ~hC</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>hC</TH><TH></TH><TH></TH><TH>uEU</TH><TH>NbL[</TH><TH>`FCc</TH><TH>`FCa</TH><TH>`FCca</TH></TR>\n";

open(FDF, "$ForbiddenDomainFile");
while(<FDF>) {
    chop;
    @tmp = split(/<>/);
    $bcheck = "";

    ### AttentionDomain
    foreach (@AttentionDomainS) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $tmp[0] ) {
	    if ( $tmplist[1] eq $tmp[3] ) {
		$tmp[0] .= "**";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $tmp[3] ) {
		$bcheck = "**";
	    }
	}
    }
    foreach (@AttentionDomain) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $tmp[0] ) {
	    if ( $tmplist[1] eq $tmp[3] ) {
		$tmp[0] .= "*";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $tmp[3] ) {
		$bcheck = "**";
	    }
	}
    }
#    $tmp[0] =~ s/\*+/\*/;
    foreach (@AttentionDomain2) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $tmp[0] ) {
	    if ( $tmplist[1] eq $tmp[3] ) {
		$tmp[0] .= "*";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $tmp[3] ) {
		$bcheck = "**";
	    }
	}
    }

    ($sec, $min, $hour, $mday) = localtime($tmp[1]);
    $tmp[1] = sprintf("%02d/%02d:%02d", $mday, $hour, $min);
    $tmp[3] = $bcheck . &AbbBrowser($tmp[3]);
    $tmp[5] =~ s/,//g;
    $tmp[6] =~ s/,//g;
    $tmp[7] =~ s/,//g;
    
    foreach $i (0..7) {
	if ( $tmp[$i] ) {
	    &PrintCell($tmp[$i]);
	} else {
	    print CLF "<TD>@</TD>";
	}
    }
    print CLF "</TR>\n";
}
close(FDF);

print CLF "</TABLE>\n";

print CLF "</BODY></HTML>\n";
close(CLF);
    

#### V[U[Í
### FA炷
### ԂlFÍ
### gpݒϐF$CaesarStr
sub CaesarCrypt {
    my ($str, $key) = @_;
    my ($pt, $pos, $i, $k, $cp, $text);
    my $nstr = length($str);
    my $ncode = length($CaesarStr);
    $text = "";

    for($i=0; $i<$nstr; $i++) {
	$pt = substr($str, $i, 1);
	if ( ( $pos = index($CaesarStr, $pt) ) >= 0) {
	    $k = ($pos + $key) % $ncode;
	    $cp = substr($CaesarStr, $k, 1);
	    $text .= $cp;
	} else {
	    $text .= $pt;
	}
    }
    return($text);

}


### Z\
sub PrintCell {

    my ($tmp) = @_;

    if ( $tmp =~ /.*\-.Z$/ ) {
	print CLF "<TD NOWRAP BGCOLOR=\"#FFFFDD\">$tmp</TD>";
    } elsif ( $tmp =~ /.*\-.Y$/ ) {
	print CLF "<TD NOWRAP BGCOLOR=\"#DDFFDD\">$tmp</TD>";
    } elsif ( $colors{$tmp} ) {
	print CLF "<TD NOWRAP BGCOLOR=\"$colors{$tmp}\">$tmp</TD>";
    } else {
	print CLF "<TD NOWRAP>$tmp</TD>";
    }
}


### 
sub DecodeIssuedList {

    my ($tmp) = @_;
    my ($sec, $min, $hour, $bcheck, $tmpdb);

    @NewCodeData = split(/<>/, $tmp);

    
    if ( $dbip ) { ### ifdef
	$RemoteDomain = $NewCodeData[2];
	if ( $RemoteDomain =~ /jp$/ ) {
	    $RemoteDomain =~ s/.*\.(.+?\..+?\.jp)$/$1/;
	    if ( $RemoteDomain !~ /\...\.jp/ ) {
		$RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
		if ( !$DomainPlace{$RemoteDomain} ) {
		    $DomainPlace{$RemoteDomain} = 3;
		}
	    }
	} elsif ( $RemoteDomain =~ /\....$/ ) {
	    $RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
	    if ( !$DomainPlace{$RemoteDomain} ) {
		$DomainPlace{$RemoteDomain} = 3;
	    }
	} else {
	    $RemoteDomain =~ s/.*\.(.+?\..+?\...)$/$1/;
	}

	$RemoteDomain2 = $NewCodeData[2];
	if ( $RemoteDomain eq "bbtec.net" ) {
	    $RemoteDomain2 =~ s/softbank(\d\d\d)\d*\./$1\./;
	} elsif ( $RemoteDomain eq "hi-ho.ne.jp" ) {
	    $RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "hinet.net" ) {
	    $RemoteDomain2 =~ s/^(\d*)\-.*\.(.+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "infoweb.ne.jp" ) {
	    if ( $RemoteDomain2 =~ /\.nt\./ || $RemoteDomain2 =~ /\.te\./ ) {
		$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	    } else {
		$RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?\..+?)$/$1\.$2/;
	    }
	} elsif ( $RemoteDomain eq "mesh.ad.jp" ) {
	    $RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "ocn.ne.jp" ) {
	    $RemoteDomain2 =~ s/\d//g;
	} elsif ( $RemoteDomain eq "odn.ad.jp"  || $RemoteDomain eq "odn.ne.jp" ) {
	    $RemoteDomain2 =~ s/^(.....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $RemoteDomain eq "prin.ne.jp" ) {
	    $RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	    $RemoteDomain2 =~ s/kd12/p061/;
	    $RemoteDomain2 =~ s/p125/p061/;
	} elsif ( $RemoteDomain eq "zaq.ne.jp" ) {
	    $RemoteDomain2 =~ s/^zaq(...).*\.(.+?\..+?\..+?)$/$1\.$2/;
	} elsif ( $DomainPlace{$RemoteDomain} == 2 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 3 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 4 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 5 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 6 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	} elsif ( $DomainPlace{$RemoteDomain} == 7 ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	} else {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
	}
	
	if ( $RemoteDomain2 =~ /ppp.dion/ ) {
	    @tmpdion = split(/\./, $NewCodeData[2]);
	    $tmpdion[0] =~ s/\d\d\d$//;
	    if ( $dionp{$tmpdion[0]} ) {
		$dionprefix = $dionp{$tmpdion[0]};
		$dionprefix =~ s/\d$//;
		$RemoteDomain2 = "$dionprefix" . "." . $RemoteDomain2;
	    }
	}

	$NewCodeData[3] = $RemoteDomain;
	$NewCodeData[15] = $RemoteDomain2;

    }

    ### dbi 
    $tmpdb = "$NewCodeData[15]<>$NewCodeData[4]";
    $tmpdbi = $DBIdentify{$tmpdb};

    foreach (@ForbiddenDomain) {
	if ( $_ && $NewCodeData[2] =~ /$_/ ) {
	    $tmpdbi = 98;
	}
    }
    if ( $NewCodeData[11] eq "05004012641412" || $NewCodeData[11] eq "05004012641607" ) {
	$tmpdbi = 2;
    }

    if ( $NewCodeData[15] =~ /infoweb/ ) {
	$tmpdomain = $NewCodeData[15];
    } else {
	$tmpdomain = join('.', reverse(split(/\./, $NewCodeData[15])));
    }

    if( $tmpdbi ) {
	$tmpindex = sprintf("$tmpdbi%d", $NewCodeData[5]);
    } else {
	$tmpindex = sprintf("99%s.%s.%d", $NewCodeData[3], $tmpdomain, $NewCodeData[5]);
    }
    $tmpindex2 = sprintf("%s.%d", $NewCodeData[4], $NewCodeData[5]);

    ### Cookie ̂Ȃꍇ
    if ( !$NewCodeData[8] && !$NewCodeData[11] ) {
	$NewCodeData[8] = "*";
    }

    ### AttentionDomain
    $bcheck = "";
    foreach (@AttentionDomainS) {
	@tmplist = split(/<>/);

	if ( $tmplist[0] eq $NewCodeData[15] ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$NewCodeData[15] .= "**";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$bcheck = "**";
	    }
	}
    }
    foreach (@AttentionDomain) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $NewCodeData[15] ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$NewCodeData[15] .= "*";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$bcheck = "**";
	    }
	}
    }
    foreach (@AttentionDomain2) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $NewCodeData[15] ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$NewCodeData[15] .= "*";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$bcheck = "**";
	    }
	}
    }

    ### uEUZk
    $NewCodeData[4] = $bcheck . &AbbBrowser($NewCodeData[4]);

    ### 
    foreach $i (5, 6, 14) {
	if ( $NewCodeData[$i] ) {
	    ($sec, $min, $hour) = localtime($NewCodeData[$i]);
	    $NewCodeData[$i] = sprintf("%02d:%02d:%02d", $hour, $min, $sec);
	}
    }

    ### Chain
    foreach $i (16, 17, 18) {
	$NewCodeData[$i] =~ s/,//g;
    }

}

### uEUZk
sub AbbBrowser {
    my ($str) = @_;

    if ( $str =~ /Firefox|Netscape/ ) {
	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT //;
	$str =~ s/; en-US;/e/;
	$str =~ s/; ja;/j/;
	$str =~ s/; ja-JP;/jJ/;
	$str =~ s/rv:.*Firefox/Ff/;
	$str =~ s/rv:.*Netscape/Ns/;
    }
    $str =~ s/.*Firefox/Firefox/;
#    $str =~ s/.*Sleipnir/Sleipnir/;
    $str =~ s/Sleipnir\//Sl/;
    $str =~ s/Opera/O/;
#    $str =~ s/.*Netscape/Netscape/;
    $str =~ s/DoCoMo\//D/;
    $str =~ s/KDDI/K/;
    $str =~ s/UP.Browser\/6.2.0.//;
    $str =~ s/Mozilla\/4.0 \(compatible; MSIE 5.5;/455/;
    $str =~ s/Mozilla\/4.0 \(compatible; MSIE 6.0;/460/;
    $str =~ s/Mozilla\/4.0 \(compatible; MSIE 7.0;/470/;
    $str =~ s/Mozilla\/4.0 \(compatible;/4/;
    $str =~ s/Mozilla\/4.08 /408/;
    $str =~ s/ Windows NT 5.1/51/;
    $str =~ s/ Windows NT 5.0/50/;
    $str =~ s/\(Windows NT 5.1/51/;
    $str =~ s/\(Windows NT 5.0/50/;
    $str =~ s/ Windows 98/98/;
    $str =~ s/ Windows CE/CE/;
    $str =~ s/; Win 9x 4.90/9x/;
    $str =~ s/; SV1/S1/;
    $str =~ s/; .NET CLR 1.0.3705/N3/;
    $str =~ s/; .NET CLR 1.1.4322/N4/;
    $str =~ s/; .NET CLR 2.0.50727/N57/;
    $str =~ s/\(PDA; NF33PPC3AR\/1.0\)/ P33/;
    $str =~ s/NetFront/NF/;
    $str =~ s/Mozilla\/5.0 \(Windows; U;/5W/;
    $str =~ s/Mozilla\/5.0 \(Macintosh; /5M/;
    $str =~ s/U; PPC Mac OS X/X/;
    if ( $str =~ /Sl/ ) {
	$str =~ s/46051S1//;
    }
    $str =~ s/^(.{15}).*/$1/;
    
    return($str);
}
